# WEB+DB PRESS Vol.92「Linuxコマンド入門」 サポートファイル

## はじめに
Linuxマシンを作成するために役に立つ[Vagrant](http://www.vagrantup.com/)というツールを紹介します。Vagrantは仮想マシンを管理するためのツールです。Vagrantを使うと仮想マシンをCLIで操作できるようになります。


## 必要なツールのインストール
次の手順でVagrantを動作させるために必要なツールをインストールします。

1. VirtualBoxのインストール
2. Vagrantのインストール

### 1. VirtualBoxのインストール
[VirtualBoxのDownloadsページ](https://www.virtualbox.org/wiki/Downloads)からインストール用パッケージを選んでダウンロードします。ホストマシンのOSにあわせて「VirtualBox 5.0.18 for Windows hosts」または「VirtualBox 5.0.18 for OS X hosts」を選びます。その後ダウンロードしたファイルを起動し、画面の指示にしたがってインストールします。

### 2. Vagrantのインストール
[VagrantのDownloadページ](https://www.vagrantup.com/downloads.html)からインストール用パッケージを選んでダウンロードします。ホストマシンのOSにあわせてWindows用またはMac用のファイルを選びます。その後ダウンロードしたファイルを起動し、画面の指示にしたがってインストールします。


## Vagrantのインストール確認
Vagrantが正しくインストールできたかを確認するために、ここで一度Vagrantコマンドを起動してみましょう。`vagrant -v`とコマンドを実行してVagrantのバージョン番号が出力されれば成功です。

Windowsの場合はコマンドプロンプト(cmd.exe)を使用してコマンドを実行します。

```
C:¥Users¥user> vagrant -v
Vagrant 1.8.0
```

Macの場合はターミナルエミュレータ(ターミナル、iTerm2など)を使用してコマンドを実行します。

```
$ vagrant -v
Vagrant 1.8.0
```


## 仮想マシンの起動、停止
作業用のディレクトリを作成し、そこに添付のVagrantfileを配置します。そのディレクトリに移動し次のコマンドを実行すると、VagrantによってVirtualBoxの仮想マシンが作成、起動されます。今回の場合はCentOS 7.0の仮想マシンが作成されます。

```
$ vagrant up
```

初回はOS本体のダウンロード、インストールが行われるためしばらく時間がかかります。2回目以降は単に仮想マシンが起動するだけです。通常のVirtualBox仮想マシンと同じようにログインして使用可能です。ログインユーザー名、パスワードはvagrant / vagrantです。

また、仮想マシンを停止するには次のコマンドを実行します。

```
$ vagrant halt
```


## sshで仮想マシンにログインする
仮想マシンが起動している状態でVagrantfileがあるディレクトリに移動して`vagrant ssh マシン名`とコマンドを実行すると、指定した仮想マシンにsshでログインできます。今回の場合はマシン名として`centos_7_0`を指定します。ユーザー名、パスワードの指定は不要です。

### 例
```
$ vagrant ssh centos_7_0
```

ただし、ホストマシンがWindowsである場合はデフォルトではsshクライアントがインストールされていないため、このコマンドは失敗します。必要に応じて別途sshクライアントをインストールしてください。


## その他のVagrantの使い方
その他のVagrantコマンドの使い方は次の通りです。

```
# 仮想マシンの状態を表示
$ vagrant status

# 仮想マシンをサスペンド
$ vagrant suspend

# サスペンドした仮想マシンを復帰
$ vagrant resume
```

仮想マシンが不要になった場合は次のコマンドで削除します。

```
# 仮想マシンを停止して削除する
$ vagrant destroy
```

Vagrantを使って仮想マシンを作成すると、Boxファイルと呼ばれる仮想マシンをインストールするときの元となるファイルもあわせて作成されます。Boxファイルは、Windowsの場合は`C:\Users/{ユーザー名}/.vagrant.d`、Macの場合は`/Users/{ユーザー名}/.vagrant.d`の下に保存されます。これも不要になった場合は`vagrant box remove Box名`で削除できます。

### 例

```
$ vagrant box remove centos_7_0
```

こうやって削除すると、次回`vagrant up`を実行したときは仮想マシンのインストールから始まります。

